	LIST    P = 16C84,  F = INHX8M, n = 66
	__config	H'3FFA'; Disable Watchdog, HS oscillator
;********************************************************
;                6,400 MHz version.
;Programmet tller inputfrekvensen p RA4 i 0,4 eller 
;4 sekunder, konverterer tallet til 7-segment cifre og ;viser dem afhngig af input p RB7.
;Outputs er aktiv lav 
;                        RB0
;                     RB5   RB1
;                        RB6
;                     RB4   RB2
;                        RB3
;
;Otte cifre vises og nummeret p aktuelt ciffer sttes p 
;RA0-RA2 med den binre vrdi 0 som mindst betydende
;ciffer, og 7 som mest betydende 
;
;RA3 styrer ind og udkobling af prescaler.
;
;********************************************************
;
INDF	equ	 0
TMR0	equ	 1
PCL	equ	 2
STATUS  	equ	 3
FSR     	equ	 4
PORT_A	equ	 5
PORT_B	equ	 6
INITCON	equ	0B
Y_byte	equ	12
X_byte	equ	13
H_byte  	equ  14
L_byte  	equ  15
R0      	equ  16              ; RAM tildelinger
R1      	equ  17
R2      	equ  18
R3		equ	19
R4		equ	1A
temp    	equ  1B
digit	equ	1C
presc	equ	1D
main	equ 	1E
inbits	equ	1F
cif0	equ	20
cif1	equ	21
cif2	equ	22
cif3	equ	23
cif4	equ	24
cif5	equ	25
cif6	equ	26
cif7	equ	27
count   	equ	28
VAROPT	equ	81
TRISA	equ	85	
TRISB	equ	86
;
;********************************************************
;               Housekeeping
;********************************************************
	bsf     STATUS,5	;skift til page 1
	movlw	0A7		;set timer p RA4
	movwf	VAROPT	;med prescaler p 256
	movlw	10
	movwf   TRISA    ;gr RA0,1,2,3 outputs og RA4 input
	movlw	80
	movwf   TRISB    ;gr RB0-6 outputs, og RB7 input
	bcf     STATUS,5 ;skift til page 0
	clrf    PORT_A   ;st alle outputs lav
	clrf    PORT_B   ;       /
	movlw	0FE
	movwf	inbits		;for at have en startvrdi
	clrf	presc

;********************************************************
;               Afls tller
;********************************************************
forever3
	bsf     STATUS,5  ;skift til page 1
	bcf	TRISA,4		;stop tller
	bcf     STATUS,5 	;skift til page 0
	comf	inbits,1	;vend inbits til aktiv hj
	bcf	STATUS,0	;og roter dem p plads
	btfsc	inbits,7	;ved at stte carry-bit=bit 7
	bsf	STATUS,0	;og rotere 
	rlf	inbits,1	;en plads til venstre
	movf    TMR0,0
	movwf   H_byte
	clrf	L_byte		; skift prescaler ud 
om
	bsf     STATUS,5  ;skift til page 1
	bsf	VAROPT,4	;vip T0SE
	bcf	VAROPT,4	;
	bcf     STATUS,5	;skift til page 0
	decf	L_byte,1
	movf	H_byte,0	;samenlign TMR0 med gammel vrdi
	subwf	TMR0,0		;hvis de er forskellige
	btfsc	STATUS,2	;d.v.s. at Z=0, skip nste instr.
	goto 	om	
	btfss	presc,3		;hvis prescaler er p
	goto	dontmpy
	movlw	6		; ganges med 64
	movwf	temp
	bcf	STATUS,0	;clear carry bit
mpy
	rlf	L_byte,1
	rlf	H_byte,1
	rlf	X_byte,1
	rlf	Y_byte,1
	decfsz	temp,1
	goto	mpy
dontmpy
	call    B2_BCD 	; Konverter til decimal
				; reprsentation i R0,R1,R2,R3,R4
				; Konverter s til 7 segments
				; reprsentation i cif0..7
	btfss	presc,3		; hvis 64 prescaler ikke er p
	goto 	convert
	movf	R3,0		; skip to cifre
	movwf	R4
	movf	R2,0
	movwf	R3
	movf	R1,0	
	movwf	R2
	movf	R0,0
	movwf	R1
convert
	movf	R4,0      ; og placer i cif0..7 med
	andlw	00F       ; mindst betydende fiffer i cif0
	call	LedTable
	movwf	cif0
	swapf	R4,0
	andlw	00F
	call	LedTable
	movwf	cif1
	movf	R3,0
	andlw	00F
	call	LedTable
	movwf	cif2
	swapf	R3,0
	andlw	00F
	call	LedTable
	movwf	cif3
	movf	R2,0
	andlw	00F
	call	LedTable
	movwf	cif4
	swapf	R2,0
	andlw	00F
	call	LedTable
	movwf	cif5		
	movf	R1,0
	andlw	00F
	call	LedTable
	movwf	cif6
	swapf	R1,0
	andlw	00F
	call	LedTable
	movwf	cif7		
	movlw	0		;beregn prescalerbit
	btfsc	inbits,2
	movlw	8
	btfsc	inbits,3
	movlw	8
	movwf	presc
	movwf	PORT_A
	movlw	.10		
	movwf	main
	clrf	TMR0		;clear timer
	clrf	X_byte
	clrf	Y_byte
bkpnt
	bsf     STATUS,5	;skift til page 1
	bsf	TRISA,4		;start tller
	bcf     STATUS,5	;skift til page 0
dbit0
	btfss	inbits,0	;hvis bit0 er sat
	goto 	dbit1
	movlw	.10		;st tid til 4 S
	movwf	main
	movlw	.116		;justering af 4 S loop
	movwf	temp
dbit1
	btfss	inbits,1	;hvis bit1 er sat
	goto 	dbit2
	movlw	.1		;st tid til 400 mS
	movwf	main
	movlw	.8		;justering af 400 mS loop
	movwf	temp
dbit2
	btfss	inbits,2	;hvis bit2 er sat
	goto 	dbit3
	movlw	.10		;st tid til 4 S
	movwf	main
	movlw	.116		;justering af 4 S loop
	movwf	temp
dbit3
	btfss	inbits,3	;hvis bit3 er sat
	goto 	dbit4
	movlw	.1		;st tid til 400 mS
	movwf	main
	movlw	.8		;justering af 400 mS loop
	movwf	temp
dbit4
dloop
	nop
	nop
	decfsz	temp,1		; loop for at justere
	goto	dloop		; tiden helt njagtigt
forever4
	movlw	.192
	movwf	digit		; antal output cifre
forever5
;********************************************************
;                   vis aktuelt ciffer
;********************************************************
	movlw	7F		;sluk display
	movwf	PORT_B
	movf    digit,0  ;ciffer nr. til w
	andlw	7		;mask ciffer nr ud
	iorwf	presc,0		;st prescalerbit
	movwf   PORT_A		;st aktuelt ciffer nummer
	andlw	7		;fjern prescaler bit igen
	addlw	20		;w peger p ciffer 
	movwf	FSR
	movf	INDF,0		;w=aktuelt 7 seg ciffer
	movwf   PORT_B	;tnd display
	rlf	PORT_B,0	;afls PORT B og
	rlf 	inbits,1	;skift bit 7 ind i inbits
;********************************************************
;                   Vent et stykke tid
;********************************************************
	movlw	.18
	movwf	count
w2	
	movlw	.59		;
	movwf	temp		;
	nop			;
	nop
w1	
	decfsz	temp,1		;
	goto 	w1
	decfsz	count,1
	goto	w2
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
;************************ slut p ventelkke ************
	btfsc	INITCON,2	;har der vret overflow ?
	goto 	incrcount2
	nop
	nop
	nop
	nop			;for at gre tidsforbruget
	nop			;identisk med nr der
	goto	cont		;har vret overflow
cont	
	decfsz	digit,1
	goto	forever5	;nste  ciffer
	decfsz	main,1
	goto	forever4	;loop er frdig
	movlw	7F		;sluk display
	movwf	PORT_B
	goto 	forever3
incrcount2
	bcf	INITCON,2	;clear overflow bit
	incf	X_byte,1	;og tl en op
	btfsc	STATUS,2	;hvis det gav overflow
	incf	Y_byte,1	;tl mest betydende byte op 
	goto 	cont	
;********************************************************
;                     Procedure B2_BCD
;           Binary Til BCD Konverterings Routine
; Rutinen konverterer et 32 bit binrt tal til et 
; 10 cifret BCD tal.
;
;Det binre tal hentes fra X_byte, H_byte og L_byte
;med mest betydende del i X_byte.
;BCD-vrdien returneres i R0, R1, R2, R3 og R4 med 
;mest betydende ciffer i R0s hjre halvdel.
;********************************************************
B2_BCD
	bcf     STATUS,0                ; clear carry bit
	movlw   .32
	movwf   count
	clrf    R0
	clrf    R1
	clrf    R2
	clrf	R3
	clrf	R4
loop16
	rlf     L_byte, F
	rlf     H_byte, F
	rlf     X_byte, F
	rlf	Y_byte, F
	rlf	R4, F
	rlf	R3, F
	rlf     R2, F
	rlf     R1, F
	rlf     R0, F
;
	decfsz  count, F
	goto    adjDEC
	RETLW   0
;
adjDEC
	movlw   R4
	movwf   FSR
	call    adjBCD
;
	movlw   R3
	movwf   FSR
	call    adjBCD
;
	movlw   R2
	movwf   FSR
	call    adjBCD
;
	movlw   R1
	movwf   FSR
	call    adjBCD
;
	movlw   R0
	movwf   FSR
	call    adjBCD
;
	goto    loop16
;
adjBCD
	movlw   3
	addwf   0,W
	movwf   temp
	btfsc   temp,3          ; test om resultat > 7
	movwf   0
	movlw   30
	addwf   0,W
	movwf   temp
	btfsc   temp,7          ; test om resultat > 7
	movwf   0               ; gem som MSD
	RETLW   0
;********************************************************
;                     Procedure led tabel, aktiv lav
;********************************************************
LedTable
        addwf   PCL,1           ;add W til PC-lav
        retlw   B'01000000'     ;led drive for 0  40
        retlw   B'01111001'     ;led drive for 1  79
        retlw   B'00100100'     ;led drive for 2  24
        retlw   B'00110000'     ;led drive for 3  30
        retlw   B'00011001'     ;led drive for 4  19
        retlw   B'00010010'     ;led drive for 5  12
        retlw   B'00000010'     ;led drive for 6  02
        retlw   B'01111000'     ;led drive for 7  78
        retlw   B'00000000'     ;led drive for 8  00
        retlw   B'00011000'     ;led drive for 9  18
        retlw   B'00001000'     ;led drive for A  
        retlw   B'00000011'     ;led drive for b
        retlw   B'01000110'     ;led drive for C
        retlw   B'00100001'     ;led drive for d
        retlw   B'00000110'     ;led drive for E
        retlw   B'00001110'     ;led drive for F


	END
